function VORadio.BuildSongList(songs)
  VORadio.Songs = iup.pdasubsubmatrix {
    numcol=4,
    expand='YES',
    edit_mode='NO',
    bgcolor='0 0 0 128 *',
    edition_cb = function()
      return iup.IGNORE
    end,
    enteritem_cb = function(self, line, col)

    end,
    leaveitem_cb = function(self, line, col)

    end
  }
  VORadio.Songs['0:1'] = 'Title'
  VORadio.Songs['0:2'] = 'Artist'
  VORadio.Songs['0:3'] = 'Album'
  VORadio.Songs['0:4'] = 'Suggest'

  VORadio.Songs['ALIGNMENT1'] = 'ALEFT'
  VORadio.Songs['ALIGNMENT2'] = 'ALEFT'
  VORadio.Songs['ALIGNMENT3'] = 'ALEFT'
  VORadio.Songs['WIDTH'.. 1]='200'
  VORadio.Songs['WIDTH'.. 2]='200'
  VORadio.Songs['WIDTH'.. 3]='200'
  VORadio.Songs['WIDTH'.. 4]='50'
  local idx = 0
  for i, v in ipairs(songs) do
    idx = idx + 1
    VORadio.Songs.ADDLIN=1
    VORadio.Songs[idx ..':1'] = v[3]
    VORadio.Songs[idx ..':2'] = v[5]
    VORadio.Songs[idx ..':3'] = v[7]
    VORadio.Songs[idx ..':4'] = iup.stationbutton {
      title = "Suggest",
      ALIGNMENT="ACENTER",
      EXPAND="NO",
      action = function(self)
        SendChat("{" .. v[2] .. "} Requesting: ".. v[3] .. " by " .. v[5], 'CHANNEL', '876') -- send to IRC bot
        HideDialog(VORadio.SongListWindow)
      end
    }
  end
  VORadio.SongListWindow = iup.dialog{ iup.hbox {
    iup.fill {},
    iup.vbox {
      iup.fill {},
      iup.stationhighopacityframe{
        expand="NO",
        size="x500",
        iup.stationhighopacityframebg{
          iup.vbox { margin="15x15",
            iup.hbox {
              iup.fill{}, iup.label { title="Songs", font=Font.H3 }, iup.fill{},
            },
            iup.fill { size="15" },
            iup.hbox {
              VORadio.Songs,
            },
            iup.fill { size="15" },
            iup.hbox {
              iup.fill {},
              VORadio.SongListcloseBtn,
              iup.fill {},
            },
          },
        },
      },
      iup.fill {},
    },
    iup.fill {},
  },
  border="NO",menubox="NO",resize="NO",
  defaultesc=VORadio.SongListcloseBtn,
  topmost="YES",
  modal="YES",
  alignment="ACENTER",
  bgcolor="0 0 0 92 *",
  fullscreen="YES"
  }
  VORadio.SongListWindow:map()
  ShowDialog(VORadio.SongListWindow, iup.CENTER, iup.CENTER)
end


VORadio.SongListcloseBtn = VORadio.SongListcloseBtn or iup.stationbutton {
  title = "Close",
  ALIGNMENT="ACENTER",
  EXPAND="NO",
  action = function(self)
    HideDialog(VORadio.SongListWindow)
  end
}
